<?php 
require_once '../vendor/autoload.php';


use Kreait\Firebase\Factory;
use Kreait\Firebase\ServiceAccount;
use Kreait\Firebase\Messaging\CloudMessage;
use Kreait\Firebase\Messaging\Notification;

$status = false;

$msg = '';

if(isset($_POST['notification_title']) and isset($_POST['notification_text'])){

    session_start();

    if($_SESSION['$role'] !=null && $_SESSION['$role'] != 'demo'){
        $factory = (new Factory)
            ->withServiceAccount('../service_account_key.json');
            //->withDatabaseUri(FIREBASE_DB_PATH);
        $auth = $factory->createAuth();

        $notification_title = $_POST['notification_title'];
        $notification_text = $_POST['notification_text'];

        try {
            $verifiedIdToken = $auth->verifyIdToken($_SESSION['$idToken']);

            $imageUrl =null;

            if(isset($_POST['notification_image'])){
                $imageUrl =$_POST['notification_image'];
            }
                    
            $messaging = $factory->createMessaging();

            $notification = Notification::create($notification_title, $notification_text,$imageUrl);
            
            $message = CloudMessage::withTarget('topic', 'all_user')
            ->withNotification($notification);
            
            $messaging->send($message);
            
            $status = true;
        } catch (FailedToVerifyToken $e) {
            $msg = 'Failed to verify token: '.$e->getMessage();
        } catch (MessagingException  $e) {
            $msg = 'Failed to Send Notification: '.$e->getMessage();
        }catch (InvalidMessage $e) {
            $msg = 'Failed to Send Notification: '.$e->getMessage();
        }catch (Exception $e) {
            $msg = 'Failed to Send Notification: '.$e->getMessage();
        }
    }else{
        $msg = 'This is a Demo Account. You cannot proceed with this action.';
    }
    
}else{
    $msg = 'missing request parameters';
}

$myObj = [ 'status' => $status,'message'=> $msg];

header('Content-type: application/json');
echo json_encode($myObj);

?>